#!/usr/bin/perl
+use FindBin;
+use lib "$FindBin::Bin";
use strict;
-my %preconfig;
-my %package;
-my %srcpackage;
-my %category;
-my %subdir;
-my %board;
-
-sub get_multiline {
- my $prefix = shift;
- my $str;
- while (<>) {
- last if /^@@/;
- s/^\s*//g;
- $str .= (($_ and $prefix) ? $prefix . $_ : $_);
- }
+use metadata;
- return $str;
-}
+my %board;
sub confstr($) {
my $conf = shift;
}
sub parse_target_metadata() {
- my ($target, @target, $profile);
- while (<>) {
+ my $file = shift @ARGV;
+ my ($target, @target, $profile);
+ my %target;
+
+ open FILE, "<$file" or do {
+ warn "Can't open file '$file': $!\n";
+ return;
+ };
+ while (<FILE>) {
chomp;
/^Target:\s*(.+)\s*$/ and do {
+ my $name = $1;
$target = {
- id => $1,
- conf => confstr($1),
- profiles => []
+ id => $name,
+ board => $name,
+ boardconf => confstr($name),
+ conf => confstr($name),
+ profiles => [],
+ features => [],
+ depends => [],
+ subtargets => []
};
push @target, $target;
- };
- /^Target-Board:\s*(.+)\s*$/ and do {
- $target->{board} = $1;
- $target->{boardconf} = confstr($1);
+ $target{$name} = $target;
+ if ($name =~ /([^\/]+)\/([^\/]+)/) {
+ push @{$target{$1}->{subtargets}}, $2;
+ $target->{board} = $1;
+ $target->{boardconf} = confstr($1);
+ $target->{subtarget} = 1;
+ $target->{parent} = $target{$1};
+ }
};
/^Target-Kernel:\s*(\d+\.\d+)\s*$/ and $target->{kernel} = $1;
/^Target-Name:\s*(.+)\s*$/ and $target->{name} = $1;
/^Target-Path:\s*(.+)\s*$/ and $target->{path} = $1;
/^Target-Arch:\s*(.+)\s*$/ and $target->{arch} = $1;
/^Target-Features:\s*(.+)\s*$/ and $target->{features} = [ split(/\s+/, $1) ];
- /^Target-Description:/ and $target->{desc} = get_multiline();
+ /^Target-Depends:\s*(.+)\s*$/ and $target->{depends} = [ split(/\s+/, $1) ];
+ /^Target-Description:/ and $target->{desc} = get_multiline(*FILE);
/^Linux-Version:\s*(.+)\s*$/ and $target->{version} = $1;
/^Linux-Release:\s*(.+)\s*$/ and $target->{release} = $1;
/^Linux-Kernel-Arch:\s*(.+)\s*$/ and $target->{karch} = $1;
};
/^Target-Profile-Name:\s*(.+)\s*$/ and $profile->{name} = $1;
/^Target-Profile-Packages:\s*(.*)\s*$/ and $profile->{packages} = [ split(/\s+/, $1) ];
- /^Target-Profile-Description:\s*(.*)\s*/ and $profile->{desc} = get_multiline();
- /^Target-Profile-Config:/ and $profile->{config} = get_multiline("\t");
+ /^Target-Profile-Description:\s*(.*)\s*/ and $profile->{desc} = get_multiline(*FILE);
+ /^Target-Profile-Config:/ and $profile->{config} = get_multiline(*FILE, "\t");
/^Target-Profile-Kconfig:/ and $profile->{kconfig} = 1;
}
+ close FILE;
foreach my $target (@target) {
+ next if @{$target->{subtargets}} > 0;
@{$target->{profiles}} > 0 or $target->{profiles} = [
{
id => 'Default',
return @target;
}
-sub parse_package_metadata() {
- my $pkg;
- my $makefile;
- my $preconfig;
- my $subdir;
- my $src;
- while (<>) {
- chomp;
- /^Source-Makefile: \s*((.+\/)([^\/]+)\/Makefile)\s*$/ and do {
- $makefile = $1;
- $subdir = $2;
- $src = $3;
- $subdir =~ s/^package\///;
- $subdir{$src} = $subdir;
- $srcpackage{$src} = [];
- undef $pkg;
- };
- /^Package:\s*(.+?)\s*$/ and do {
- $pkg = {};
- $pkg->{src} = $src;
- $pkg->{makefile} = $makefile;
- $pkg->{name} = $1;
- $pkg->{default} = "m if ALL";
- $pkg->{depends} = [];
- $pkg->{builddepends} = [];
- $pkg->{subdir} = $subdir;
- $package{$1} = $pkg;
- push @{$srcpackage{$src}}, $pkg;
- };
- /^Version: \s*(.+)\s*$/ and $pkg->{version} = $1;
- /^Title: \s*(.+)\s*$/ and $pkg->{title} = $1;
- /^Menu: \s*(.+)\s*$/ and $pkg->{menu} = $1;
- /^Submenu: \s*(.+)\s*$/ and $pkg->{submenu} = $1;
- /^Submenu-Depends: \s*(.+)\s*$/ and $pkg->{submenudep} = $1;
- /^Default: \s*(.+)\s*$/ and $pkg->{default} = $1;
- /^Provides: \s*(.+)\s*$/ and do {
- my @vpkg = split /\s+/, $1;
- foreach my $vpkg (@vpkg) {
- $package{$vpkg} or $package{$vpkg} = { vdepends => [] };
- push @{$package{$vpkg}->{vdepends}}, $pkg->{name};
- }
- };
- /^Depends: \s*(.+)\s*$/ and $pkg->{depends} = [ split /\s+/, $1 ];
- /^Build-Depends: \s*(.+)\s*$/ and $pkg->{builddepends} = [ split /\s+/, $1 ];
- /^Category: \s*(.+)\s*$/ and do {
- $pkg->{category} = $1;
- defined $category{$1} or $category{$1} = {};
- defined $category{$1}->{$src} or $category{$1}->{$src} = [];
- push @{$category{$1}->{$src}}, $pkg;
- };
- /^Description: \s*(.*)\s*$/ and $pkg->{description} = "\t\t $1\n". get_multiline("\t\t ");
- /^Config: \s*(.*)\s*$/ and $pkg->{config} = "$1\n".get_multiline();
- /^Prereq-Check:/ and $pkg->{prereq} = 1;
- /^Preconfig:\s*(.+)\s*$/ and do {
- my $pkgname = $pkg->{name};
- $preconfig{$pkgname} or $preconfig{$pkgname} = [];
- $preconfig = {
- id => $1
- };
- push @{$preconfig{$pkgname}}, $preconfig;
- };
- /^Preconfig-Type:\s*(.*?)\s*$/ and $preconfig->{type} = $1;
- /^Preconfig-Label:\s*(.*?)\s*$/ and $preconfig->{label} = $1;
- /^Preconfig-Default:\s*(.*?)\s*$/ and $preconfig->{default} = $1;
- }
- return %category;
-}
-
sub gen_kconfig_overrides() {
my %config;
my %kconfig;
while ($_ = shift @_) {
/broken/ and $ret .= "\tdepends BROKEN\n";
+ /display/ and $ret .= "\tselect DISPLAY_SUPPORT\n";
+ /gpio/ and $ret .= "\tselect GPIO_SUPPORT\n";
/pci/ and $ret .= "\tselect PCI_SUPPORT\n";
/usb/ and $ret .= "\tselect USB_SUPPORT\n";
/pcmcia/ and $ret .= "\tselect PCMCIA_SUPPORT\n";
/jffs2/ and $ret .= "\tselect USES_JFFS2\n";
/ext2/ and $ret .= "\tselect USES_EXT2\n";
/tgz/ and $ret .= "\tselect USES_TGZ\n";
+ /cpiogz/ and $ret .= "\tselect USES_CPIOGZ\n";
}
return $ret;
}
+sub target_name($) {
+ my $target = shift;
+ my $parent = $target->{parent};
+ if ($parent) {
+ return $target->{parent}->{name}." - ".$target->{name};
+ } else {
+ return $target->{name};
+ }
+}
+
+sub kver($) {
+ my $v = shift;
+ $v =~ tr/\./_/;
+ $v =~ /(\d+_\d+_\d+)(_\d+)?/ and $v = $1;
+ return $v;
+}
+
+sub print_target($) {
+ my $target = shift;
+ my $features = target_config_features(@{$target->{features}});
+ my $help = $target->{desc};
+ my $kernel = $target->{kernel};
+ my $confstr;
+ $kernel =~ tr/./_/;
+
+ chomp $features;
+ $features .= "\n";
+ if ($help =~ /\w+/) {
+ $help =~ s/^\s*/\t /mg;
+ $help = "\thelp\n$help";
+ } else {
+ undef $help;
+ }
+
+ my $v = kver($target->{version});
+ $confstr = <<EOF;
+config TARGET_$target->{conf}
+ bool "$target->{name}"
+ select LINUX_$kernel
+ select LINUX_$v
+EOF
+ if ($target->{subtarget}) {
+ $confstr .= "\tdepends TARGET_$target->{boardconf}\n";
+ }
+ if (@{$target->{subtargets}} > 0) {
+ $confstr .= "\tselect HAS_SUBTARGETS\n";
+ } else {
+ $confstr .= "\tselect $target->{arch}\n";
+ foreach my $dep (@{$target->{depends}}) {
+ my $mode = "depends";
+ my $flags;
+ my $name;
+
+ $dep =~ /^([@\+\-]+)(.+)$/;
+ $flags = $1;
+ $name = $2;
+
+ $flags =~ /-/ and $mode = "deselect";
+ $flags =~ /\+/ and $mode = "select";
+ $flags =~ /@/ and $confstr .= "\t$mode $name\n";
+ }
+ $confstr .= $features;
+ }
+
+ $confstr .= "$help\n\n";
+ print $confstr;
+}
sub gen_target_config() {
my @target = parse_target_metadata();
- @target = sort {
- $a->{name} cmp $b->{name}
+ my @target_sort = sort {
+ target_name($a) cmp target_name($b);
} @target;
-
-
+
+
print <<EOF;
choice
prompt "Target System"
EOF
- foreach my $target (@target) {
- my $features = target_config_features(@{$target->{features}});
- my $help = $target->{desc};
- my $kernel = $target->{kernel};
- $kernel =~ tr/./_/;
-
- chomp $features;
- $features .= "\n";
- if ($help =~ /\w+/) {
- $help =~ s/^\s*/\t /mg;
- $help = "\thelp\n$help";
- } else {
- undef $help;
- }
-
- print <<EOF;
-config TARGET_$target->{conf}
- bool "$target->{name}"
- select $target->{arch}
- select LINUX_$kernel
-EOF
- if ($target->{id} ne $target->{board}) {
- print "\tselect TARGET_".$target->{boardconf}."\n";
- }
- print "$features$help\n\n"
+ foreach my $target (@target_sort) {
+ next if $target->{subtarget};
+ print_target($target);
}
print <<EOF;
endchoice
-config TARGET_BOARD
- string
+choice
+ prompt "Subtarget" if HAS_SUBTARGETS
+
EOF
foreach my $target (@target) {
- print "\t\tdefault \"".$target->{board}."\" if TARGET_".$target->{conf}."\n";
+ next unless $target->{subtarget};
+ print_target($target);
}
- # add hidden target config options
- foreach my $target (@target) {
- next if $board{$target->{board}};
- if ($target->{id} ne $target->{board}) {
- print "\nconfig TARGET_".$target->{boardconf}."\n\tbool\n";
- $board{$target->{board}} = 1;
- }
- }
- print <<EOF;
+print <<EOF;
+endchoice
choice
prompt "Target Profile"
EOF
-
+
foreach my $target (@target) {
my $profiles = $target->{profiles};
-
+
foreach my $profile (@$profiles) {
print <<EOF;
config TARGET_$target->{conf}_$profile->{id}
}
}
- print "endchoice\n";
-}
+ print <<EOF;
+endchoice
+config HAS_SUBTARGETS
+ bool
-sub find_package_dep($$) {
+config TARGET_BOARD
+ string
+
+EOF
+ foreach my $target (@target) {
+ $target->{subtarget} or print "\t\tdefault \"".$target->{board}."\" if TARGET_".$target->{conf}."\n";
+ }
+
+ my %kver;
+ foreach my $target (@target) {
+ my $v = kver($target->{version});
+ next if $kver{$v};
+ $kver{$v} = 1;
+ print <<EOF;
+config LINUX_$v
+ bool
+EOF
+ }
+}
+
+my %dep_check;
+sub __find_package_dep($$) {
my $pkg = shift;
my $name = shift;
my $deps = ($pkg->{vdepends} or $pkg->{depends});
return 0 unless defined $deps;
foreach my $dep (@{$deps}) {
+ next if $dep_check{$dep};
+ $dep_check{$dep} = 1;
return 1 if $dep eq $name;
- return 1 if ($package{$dep} and (find_package_dep($package{$dep},$name) == 1));
+ return 1 if ($package{$dep} and (__find_package_dep($package{$dep},$name) == 1));
}
return 0;
}
+# wrapper to avoid infinite recursion
+sub find_package_dep($$) {
+ my $pkg = shift;
+ my $name = shift;
+
+ %dep_check = ();
+ return __find_package_dep($pkg, $name);
+}
+
sub package_depends($$) {
my $a = shift;
my $b = shift;
my $depends = shift;
my $only_dep = shift;
my $res;
+ my $dep = shift;
+ $dep or $dep = {};
$depends or return;
my @depends = @$depends;
$depend =~ s/^([@\+]+)//;
my $flags = $1;
my $vdep;
-
+
if ($vdep = $package{$depend}->{vdepends}) {
$depend = join("||", map { "PACKAGE_".$_ } @$vdep);
} else {
# thus if FOO depends on other config options, these dependencies
# will not be checked. To fix this, we simply emit all of FOO's
# depends here as well.
- $package{$depend} and $res .= mconf_depends($package{$depend}->{depends}, 1);
+ $package{$depend} and mconf_depends($package{$depend}->{depends}, 1, $dep);
};
$flags =~ /@/ or $depend = "PACKAGE_$depend";
}
+ $dep->{$depend} =~ /select/ or $dep->{$depend} = $m;
+ }
+ foreach my $depend (keys %$dep) {
+ my $m = $dep->{$depend};
$res .= "\t\t$m $depend\n";
}
return $res;
my $cat = shift;
my %menus;
my %menu_dep;
-
+
return unless $category{$cat};
-
+
print "menu \"$cat\"\n\n";
my %spkg = %{$category{$cat}};
-
+
foreach my $spkg (sort {uc($a) cmp uc($b)} keys %spkg) {
foreach my $pkg (@{$spkg{$spkg}}) {
my $menu = $pkg->{submenu};
print "\t";
$pkg->{menu} and print "menu";
print "config PACKAGE_".$pkg->{name}."\n";
- print "\t\ttristate \"$title\"\n";
+ print "\t\t".($pkg->{tristate} ? 'tristate' : 'bool')." \"$title\"\n";
print "\t\tdefault y if DEFAULT_".$pkg->{name}."\n";
foreach my $default (split /\s*,\s*/, $pkg->{default}) {
print "\t\tdefault $default\n";
}
}
print "endmenu\n\n";
-
+
undef $category{$cat};
}
sub gen_package_config() {
- parse_package_metadata();
+ parse_package_metadata($ARGV[0]) or exit 1;
print "menuconfig UCI_PRECONFIG\n\tbool \"Image configuration\"\n";
foreach my $preconfig (keys %preconfig) {
- foreach my $cfg (@{$preconfig{$preconfig}}) {
- my $conf = $cfg->{id};
+ foreach my $cfg (keys %{$preconfig{$preconfig}}) {
+ my $conf = $preconfig{$preconfig}->{$cfg}->{id};
$conf =~ tr/\.-/__/;
print <<EOF
config UCI_PRECONFIG_$conf
- string "$cfg->{label}" if UCI_PRECONFIG
+ string "$preconfig{$preconfig}->{$cfg}->{label}" if UCI_PRECONFIG
depends PACKAGE_$preconfig
- default "$cfg->{default}"
+ default "$preconfig{$preconfig}->{$cfg}->{default}"
EOF
}
my %dep;
my $line;
- parse_package_metadata();
+ parse_package_metadata($ARGV[0]) or exit 1;
foreach my $name (sort {uc($a) cmp uc($b)} keys %package) {
my $config;
my $pkg = $package{$name};
-
+
next if defined $pkg->{vdepends};
if ($ENV{SDK}) {
$conf{$pkg->{src}} or do {
print "package-$config += $pkg->{subdir}$pkg->{src}\n";
$pkg->{prereq} and print "prereq-$config += $pkg->{subdir}$pkg->{src}\n";
}
-
+
my $hasdeps = 0;
my $depline = "";
foreach my $dep (@{$pkg->{depends}}, @{$pkg->{builddepends}}) {
$line .= "\$(curdir)/".$pkg->{subdir}."$pkg->{src}/compile += $depline\n";
}
}
-
+
if ($line ne "") {
print "\n$line";
}
foreach my $preconfig (keys %preconfig) {
my $cmds;
- foreach my $cfg (@{$preconfig{$preconfig}}) {
- my $conf = $cfg->{id};
+ foreach my $cfg (keys %{$preconfig{$preconfig}}) {
+ my $conf = $preconfig{$preconfig}->{$cfg}->{id};
$conf =~ tr/\.-/__/;
- $cmds .= "\techo \"uci set '$cfg->{id}=\$(subst \",,\$(CONFIG_UCI_PRECONFIG_$conf))'\"; \\\n";
+ $cmds .= "\techo \"uci set '$preconfig{$preconfig}->{$cfg}->{id}=\$(subst \",,\$(CONFIG_UCI_PRECONFIG_$conf))'\"; \\\n";
}
next unless $cmds;
print <<EOF